MCAk <- function(data,nclus=3,ndim=2,nstart=100,smartStart=F,seed=1234){
  require("corpcor")
  require("dummies")
  source("EmptyKmeans.r")
  zz=as.matrix(dummy.data.frame(data))
  data = data.matrix(data)
  
  
  minobs = min(data)
  maxobs = max(data)
  
  n=nrow(data)
  zitem=ncol(data)            
  q=zitem
  if ((minobs==0) & (maxobs==1)) {
    zncati=apply(data,2,max)+1 
  } else {
    zncati=apply(data,2,max)
  }
  
  
  zncat= sum(zncati)    
  oner = matrix(1,n,1)
  muz  = apply(zz,2,mean)
  z= zz-oner %*% muz  
  rr=apply(t(zz) %*% zz,2,sum )
  Dr=diag(rr)
  sqDr=diag(sqrt(rr))
  invsqDr = diag(1/sqrt(rr))
  M=z
  Pz=z %*% invsqDr
  PPz=t(Pz) %*% Pz
  
  evdPz = eigen(PPz)
  V=evdPz$vectors[,1:ndim]
  
  D=diag(sqrt(evdPz$values[1:ndim]))
  
  invsqD=diag((1/sqrt(sqrt(evdPz$values[1:ndim]))))
  Fm=Pz %*% V %*% invsqD
  F0=Fm#[,1:ndim]
  
  oldf=1000000
  fvec=c()
  for(b in 1:nstart){
    Fv={}
    Fm= F0
    
    set.seed(seed+b)
    
    index0=matrix(ceiling(runif(n)*nclus),n,1)
    
    if(smartStart==T){
      index0=kmeans(Fm,nclus,nstart=100)$cluster
    }
    
    U=dummy(index0 )
    
  
    center= pseudoinverse(t(U) %*% U) %*% t(U) %*% Fm 
    itmax= 100
    it = 0
    ceps= 0.0001
    imp = 100000
    f0 = 100000
    
    itwhile=0 
    
    while((it <= itmax ) && ( imp > ceps ) ){
      it=it+1
      itwhile=itwhile+1
      
      ####################################################################
      ## STEP 1: update of U #############################################
      ####################################################################
      outK=try(kmeans(Fm,centers=center),silent=T)
      if(is.list(outK)==F){
        #print("singleton")
        outK=EmptyKmeans(Fm,centers=center)  
      }
      center=outK$centers
      index = outK$cluster
      U=dummy(factor(index))
      U0=U-oner %*% apply(U,2,mean)
      uu=apply(t(U)%*% U ,2,sum)
      Dru=diag(c(rr,uu))
      sqDru=diag(sqrt(c(rr,uu)))
      invsqDru=diag(1/sqrt(c(rr,uu)))
      
      ####################################################################
      ## STEP 2: update of Fm and Wj ######################################
      ####################################################################
      
      MU=cbind(M,U0)
      Pzu=MU %*% invsqDru
      wzero=(which(Pzu=="NaN",arr.ind=T))
      Pzu[wzero]=0
      PPzu=t(Pzu) %*% Pzu
      
  
      evdPzu = eigen(PPzu)#,LINPACK=T)
  
      Q=evdPzu$vectors[,1:ndim]
      
      lambda=evdPzu$values
      
      D=diag(sqrt(evdPzu$values[1:ndim]))
      sqD=diag(sqrt(sqrt(evdPzu$values[1:ndim])))
      invsqD = diag(1/sqrt(sqrt(evdPzu$values[1:ndim])))
      
  
      Fm= Pzu %*% Q %*% invsqD
  
      ft1=0
      k=1
      kk=0
      
      kk=kk+zncati[1]
      Tm=z[,k:kk]
      
      W=pseudoinverse(t(Tm)%*% Tm)%*% t(Tm) %*% Fm
      A=W
      ft1=ft1+sum(diag(t(Fm) %*% Fm-t(Fm) %*% Tm %*% W))
      k=kk+1
      
      for(j in 2:zitem){
        kk=kk+zncati[j]
        Tm=z[,k:kk]
        W=pseudoinverse(t(Tm)%*% Tm)%*% t(Tm) %*% Fm
        A=rbind(A,W)
        ft1=ft1 + sum(diag(t(Fm) %*% Fm-t(Fm) %*% Tm %*% W)) ## MCA criterion
        k=kk+1
      }
      
      ft2=sum(diag(t(Fm) %*% Fm)-t(Fm) %*% U %*% center) ## cluster criterion
      f=ft1+ft2
      imp=f0-f
      f0=f
      Fv = cbind(Fv,f)
    } # end WHILE
    fvec=c(fvec,f)
    inert=sum(lambda[1:2])
    t_inert=sum(lambda)
    
    if (f<= oldf){
      oldinert=inert
      t_oldinert=t_inert
      oldF=Fm
      oldindex=index
      oldf=f				
      Uold=U				
      Aold=A
      centerold = center
      itold=it
    }
  } ##end of FOR
  
  
  ##############
  #################################
  #################################
  ZkG=U%*%center
  nmods=apply(data,2,function(x) length(levels(factor(x))))
  all_mo=length(nmods)
  cmods=cumsum(nmods)
  mod_start=c(1,cmods[1:(all_mo-1)]+1)
  mod_end=cmods
  
  
  ZBjs=matrix(0,nrow=ndim,ncol=ndim)
  final_loss=0
  for(ii in 1:all_mo){
    ZjBj=zz[,mod_start[ii]:mod_end[ii]]%*%A[mod_start[ii]:mod_end[ii],]
    YZjBj=Fm-ZjBj
    loss_a_j=sum(diag(t(YZjBj) %*% YZjBj))
    final_loss=final_loss+loss_a_j
    ZBjs=ZBjs+t(ZjBj) %*% ZjBj
  }
  FmZkG=Fm-ZkG
  loss_b_j=sum(diag(t(FmZkG)%*%FmZkG))
  final_loss=(1/q)*.5*final_loss+.5*loss_b_j
  #######################################
  
  
  
  out=list()
  
  Fm=oldF
  index=oldindex
  f=oldf
  U=Uold
  A=Aold
  it=itold
  center=centerold
  
  out$obscoord=Fm # observations coordinates 
  out$attcoord=A # attributes coordinates 
  out$centroid=center # centroids
  out$cluID=as.numeric(index) # cluster membership
  out$criterion=f # criterion
  out$iters=it # number of iterations
  out
}  