PaperAppHSQ<-function(output,K,dim1=1,dim2=2,picInPic=F,odata,labs=LongLab,skipMap=F,splitMap=F){
  source("outOfIndependence.r")
  require("ggplot2")
  require("ggrepel")
  if(skipMap==F){
    if(splitMap==T){
      glab=paste(rep("C",K),1:K,sep="")
      
      
      xallmax=max(max(output$attcoord[,dim1]),max(output$obscoord[,dim1]))
      xallmin=min(min(output$attcoord[,dim1]),min(output$obscoord[,dim1]))
      yallmax=max(max(output$attcoord[,dim2]),max(output$obscoord[,dim2]))
      yallmin=min(min(output$attcoord[,dim2]),min(output$obscoord[,dim2]))
      
      
      
      #pdf(file=paste("K",deparse(K),"MapHSQunits.pdf",sep=""),height=9 , width=9)
      
      
      
      xallmax=max(max(output$attcoord[,dim1]),max(output$obscoord[,dim1]))
      xallmin=min(min(output$attcoord[,dim1]),min(output$obscoord[,dim1]))
      yallmax=max(max(output$attcoord[,dim2]),max(output$obscoord[,dim2]))
      yallmin=min(min(output$attcoord[,dim2]),min(output$obscoord[,dim2]))
      x_all_range=xallmax-xallmin
      y_all_range=yallmax-yallmin
      all_range=max(x_all_range,y_all_range)
      xallmax=xallmin+all_range
      yallmax=yallmin+all_range
      
      xattmax=max(output$attcoord[,dim1])
      xattmin=min(output$attcoord[,dim1])
      yattmax=max(output$attcoord[,dim2])
      yattmin=min(output$attcoord[,dim2])
      x_att_range=xattmax-xattmin
      y_att_range=yattmax-yattmin
      att_range=max(x_att_range,y_att_range)
      xattmax=xattmin+att_range
      yattmax=yattmin+att_range
      ######################################################
      
      
      
      
      att_df=data.frame(d1=output$attcoord[,dim1],d2=output$attcoord[,dim2],attnam=labs)
      xact=union(which(att_df$d1> .5),which(att_df$d1< -.5))
      yact=union(which(att_df$d2>.5), which(att_df$d2< -.5))
      xyact=union(xact,yact)
      att_df$act=rep("inner",nrow(att_df))
      att_df$act[xyact]="outer"
      
      
      group_df= data.frame(d1=output$centroid[,dim1],d2=output$centroid[,dim2],glab=glab)
      obs_df=data.frame(d1=output$obscoord[,dim1],d2=output$obscoord[,dim2],gr=factor(output$cluID))
      
      a=ggplot(data=obs_df,aes(x=d1,y=d2,colour=gr,shape=gr))+xlim(xallmin,xallmax)+ylim(yallmin,yallmax)
      a=a+geom_point(aes(x=d1,y=d2,colour=gr,shape=gr,alpha=.4),size=1)+theme_bw()
      a=a+theme(legend.position="none",axis.text.x = element_blank(),axis.text.y = element_blank())+xlab("")+ylab("")
      a=a+geom_vline(xintercept=0)+geom_hline(yintercept=0)
      ggsave(file=paste("K",deparse(K),"MapHSQunits.pdf",sep=""),a,height=8 , width=8)
      
      xallmax=xattmax
      xallmin=xattmin
      yallmax=yattmax
      yallmin=yattmin
      
      a=ggplot(data=att_df,aes(x=d1,y=d2))+xlim(xallmin,xallmax)+ylim(yallmin,yallmax)
      a=a+geom_point(alpha=.5,size=.25)+theme_bw()+xlab("")+ylab("")
      a=a+geom_text_repel(data=subset(att_df,act=="outer"),aes( label = attnam),size=2,segment.size = 0.1)
      a=a+geom_text(data=subset(att_df,act!="outer"),aes( label = attnam),size=2)
      a=a+geom_point(data=group_df,aes(x=d1,y=d2,shape=glab))+theme(legend.position="none",axis.text.x = element_blank(),axis.text.y = element_blank())
      a=a+geom_text_repel(data=group_df,aes(label=glab))
      a=a+geom_vline(xintercept=0)+geom_hline(yintercept=0)
      ggsave(file=paste("K",deparse(K),"MapHSQattributes.pdf",sep=""),a,height=8 , width=8)
      
      
    }else{
      glab=paste(rep("C",K),1:K,sep="")
      
      # pdf(file=paste("K",deparse(K),"MapHSQ.pdf",sep=""),height=9 , width=9)
      xallmax=max(max(output$attcoord[,dim1]),max(output$obscoord[,dim1]))
      xallmin=min(min(output$attcoord[,dim1]),min(output$obscoord[,dim1]))
      yallmax=max(max(output$attcoord[,dim2]),max(output$obscoord[,dim2]))
      yallmin=min(min(output$attcoord[,dim2]),min(output$obscoord[,dim2]))
      x_all_range=xallmax-xallmin
      y_all_range=yallmax-yallmin
      all_range=max(x_all_range,y_all_range)
      xallmax=xallmin+all_range
      yallmax=yallmin+all_range
      
      att_df=data.frame(d1=output$attcoord[,dim1],d2=output$attcoord[,dim2],attnam=labs)
      xact=union(which(att_df$d1> .5),which(att_df$d1< -.5))
      yact=union(which(att_df$d2>.5), which(att_df$d2< -.5))
      xyact=union(xact,yact)
      att_df$act=rep("inner",nrow(att_df))
      att_df$act[xyact]="outer"
      
      
      group_df= data.frame(d1=output$centroid[,dim1],d2=output$centroid[,dim2],glab=glab)
      obs_df=data.frame(d1=output$obscoord[,dim1],d2=output$obscoord[,dim2],gr=factor(output$cluID))
      
      a=ggplot(data=att_df,aes(x=d1,y=d2))+xlim(xallmin,xallmax)+ylim(yallmin,yallmax)
      a=a+geom_point(alpha=.5,size=.25)+theme_bw()+xlab("")+ylab("")
      a=a+geom_text_repel(data=subset(att_df,act=="outer"),aes( label = attnam),size=2.25,segment.size = 0.1)
      a=a+geom_text(data=subset(att_df,act!="outer"),aes( label = attnam),size=2.25)
      a=a+geom_point(data=group_df,aes(x=d1,y=d2,shape=glab))
      a=a+geom_text_repel(data=group_df,aes(label=glab))+theme(legend.position="none",axis.text.x = element_blank(),axis.text.y = element_blank())
      a=a+geom_point(data=obs_df,aes(x=d1,y=d2,colour=gr,shape=gr,alpha=.25),size=1)
      a=a+geom_vline(xintercept=0)+geom_hline(yintercept=0)
      
      ggsave(file=paste("K",deparse(K),"MapHSQ.pdf",sep=""),a,height=8 , width=8)
      #+geom_text(label=labs,size=1.75)
      # par(mfrow=c(1,1))
      # #plotTitle=paste("CAclus_","(",deparse(round(CAclusHSQ$expl_inertia,digits=3)),"%",")",sep="")
      # plotTitle=paste("CAclus")
      # plot(output$obscoord,pch=output$cluID+1,cex=.5,col=output$cluID+1,xlim=c(xallmin,xallmax),ylim=c(yallmin,yallmax),xlab="dim 1",ylab="dim 2")#,type="n")main=plotTitle,
      # text(output$attcoord,col="grey40", cex=.7,label=labs)
      # #text(Rclus_k$centroid,label=c("G1","G2","G3","G4"), cex=1)
      # points(output$centroid,cex=2,col="black",pch=c(2,4,3))
      # text(output$centroid,label=glab,col="black", cex=1.25,pos=1)
      # dev.off()    
      #c("red","forestgreen","blue")
    }  
    
  }
  
  if(picInPic==T){
    TopplotGroups=outOfIndependence(odata,output$cluID,labs,firstfew=20,textSize=4,segSize=4,minx=-2.5,maxx=2.5)
    plotGroups=outOfIndependence(odata,output$cluID,nolabs=T,labs,fixmarg=T,textSize=1.5,segSize=1.5,minx=-2.5,maxx=2.5)
    require("grid")
    for(jjj in 1:K){
      TopplotGroups$G[[jjj]]=TopplotGroups$G[[jjj]]+theme_bw() 
      plotname=paste(deparse(substitute(output)),"G",deparse(jjj),"picInpic.pdf",sep="")
      pdf(file=plotname,height=9 , width=9)
      print(TopplotGroups$G[[jjj]])
      print(plotGroups$G[[jjj]], vp=viewport(.15, .18, .3, .35))
      dev.off()
      
      #plotGroups$G[[jjj]]=plotGroups$G[[jjj]]+theme_bw()
    }
    
    
  }
  
}
