groupals <- function(data,nclus=3,ndim=2,nstart=100,smartStart=F,seed=1234,randMat=NULL){
  require("dummies")
  source("EmptyKmeans.r")


  zz=as.matrix(dummy.data.frame(data))
  
  data=data.matrix(data)
  minobs = min(data)
  maxobs = max(data)

  if ((minobs==0) & (maxobs==1)) {
    zncati=apply(data,2,max)+1 
  } else {
    zncati=apply(data,2,max)
  }
  zncat=sum(zncati)
  
  q=ncol(data)
  n=nrow(data)
  
  
  onen=matrix(1,nrow=n,ncol=1)
  mu_zz=apply(zz,2,mean)
  z=zz - onen %*% mu_zz
  
  rr=diag(t(zz) %*% zz)
  Dr=diag(rr)
  invDr=diag(1/sqrt(rr))
  Pz=z %*% invDr
  
  
  
  evdRes=svd(t(Pz)%*% Pz)
  V=evdRes$v[,1:ndim]
  
  D=diag((evdRes$d[1:ndim]))
  
  invSqD=diag(1/(sqrt(evdRes$d[1:ndim])))
  
  
  Fv=Pz%*%V %*% invSqD
  F0=Fv[,1:ndim]
  
  oldf = 1000000                   
  fvec=c()
  lossvec=c()
  for (b in 1:nstart){
    Fv=F0
    if(is.null(randMat)){
      myseed=seed+b
      set.seed(myseed)
      randVec=floor(runif(n,min=1,max=(nclus+1)))
    }else{
      randVec=randMat[,b]
    }
  
    index0=randVec
  
    if(smartStart==T){
      index0=kmeans(Fv,nclus,nstart=100)$cluster
    }
    
    U=dummy(factor(index0))
    
    A=matrix(0,nrow=zncat, ncol=ndim)
    itmax=100
    it=0
    ceps = 0.00001           
    imp = 100000            
    f0 = 1000000
    
    while ((it <= itmax) && (imp > ceps)){
      it=it+1  
      kk=0
      H = matrix(0,ndim,ndim) ## update Wj (step 2 of vB&H algorithm)
      T0 = matrix(0,n,ndim)
      
      for(j in 1:q){
        k = kk+1
        kk = kk + zncati[j]
        Zk = z[,k:kk]
        Dz = diag(rr[k:kk])
        ZkFv = t(Zk) %*% Fv
        W = solve(Dz) %*% ((ZkFv))
  
        H = H + t(W) %*% Dz %*% W
        T0 = T0 + Zk %*% W
        A[k:kk,]=W
      }
      # update Z (step3 of of vB&H algorithm)
      H=H/q 
      
      evdRes=svd(H)
      d=diag(evdRes$d[1:ndim])
      v=evdRes$v[,1:ndim]
      inv_d_sq=diag(1/sqrt(evdRes$d[1:ndim]))
  
      Tv=(1/q) * T0 %*% v %*% inv_d_sq
  
      center = solve(t(U) %*% U) %*% (t(U) %*% Tv)
      
      
      outK=try(kmeans(Tv,centers=center,nstart=100),silent=T) # Kmeans (step4 of of vB&H algorithm)
      if(is.list(outK)==F){
  
        outK=EmptyKmeans(Tv,centers=center)  
      }
  
      center=outK$centers
      
      index = outK$cluster
      U=dummy(factor(index))
      Fv = U %*% center   ## (step5 of of vB&H algorithm)
      evdRRes=svd(t(Fv) %*% Fv)
      
      dd=diag((evdRRes$d))
      inv_dd_sq = diag(1/(sqrt(evdRRes$d)))
      if((b==1)&(it==1)){
  
      }
      vv = evdRRes$v
      Fv = Fv %*% vv %*% inv_dd_sq
  
      f=0
      kk=0
      for(j in 1:q){# (step6 of of vB&H algorithm)
        k=kk+1
        kk = kk + zncati[j]
        dif = Fv-z[,k:kk] %*% A[k:kk,]
        f=f + sum(diag(t(dif)%*% dif))
      }
      
      
      imp= f0 - f
      
      f0=f
      
    }# endwhile
  
    fvec=c(fvec,f)
    
    ZkG=U%*%center
    ZB=z%*%A
    
    myloss=(1/q)*sum(diag(t(ZkG-ZB)%*%(ZkG-ZB)))
    lossvec=c(lossvec,myloss)
    if (f <= oldf){
      oldf = f
  
      Uold = U
      Aold = A
      Fvold=Fv
      Told=Tv
      indexold = index
      centeroid = center
      itold=it
      
    }
  }
  f = oldf
  U = Uold
  A = Aold
  Fv=Fvold
  Tv=Told
  index = indexold
  center = centeroid
  group_membership = index
  nclass = apply(U,2,sum)
  it=itold
  
  ZkG=U%*%center
  ZB=z%*%A
  
  final_loss=(1/q)*sum(diag(t(ZkG-ZB)%*%(ZkG-ZB)))
  
  nmods=apply(data,2,function(x) length(levels(factor(x))))
  all_mo=length(nmods)
  cmods=cumsum(nmods)
  mod_start=c(1,cmods[1:(all_mo-1)]+1)
  mod_end=cmods
  
  
  final_loss=0
  ZBjs=matrix(0,nrow=ndim,ncol=ndim)
  for(ii in 1:all_mo){
    ZjBj=zz[,mod_start[ii]:mod_end[ii]]%*%A[mod_start[ii]:mod_end[ii],]
    ZkGZjBj=ZkG-ZjBj
    lossj=sum(diag(t(ZkGZjBj) %*% ZkGZjBj))
    final_loss=final_loss+lossj
    ZBjs=ZBjs+t(ZjBj) %*% ZjBj
  }
  final_loss=(1/q)*final_loss
  # print("final_loss")
  # print(final_loss)
  
  ZkGTv = t(center)%*% t(U) %*%  Tv
  trZkGTv= sum(diag(ZkGTv))
  obj=(ndim- trZkGTv) /ncol(data)
  # print("obj")
  # print(obj)
  compare_val= sum(diag(t(ZkG) %*% ZkG))
  
  out=list()
  out$obscoord=Tv # observations coordinates
  out$attcoord=A # attributes coordinates
  out$centroid=center # centroids
  out$cluID=index # cluster membership
  out$criterion=f # criterion
  out$iters=it # number of iterations
  out
}