rm(list=ls(all=T))
install.packages(c("cluster","dummies","ca","fpc","vegan","ggplot2","GGally","bootSVD","ggrepel","corpcor"))
require("cluster")
require("dummies")
require("xtable")
require("vegan")
require("fpc")
require("vegan")
require("ca")
require("ggrepel")
source("PatProcrus.r")
source("clusCA.r")
source("MCAk.r")
source("iFCB.r")
source("groupals.r")
source("tandemMCA_Kmeans.r")



HSQall=read.csv("HSQ_data.csv",header=T)
hsqQuestions=read.table("QuestionsHSQ.txt",header=T, sep=".")
hsqQuestions$X=c()

HSQ=HSQall[,1:32]
N=nrow(HSQ)
q=ncol(HSQ)

for(jj in 1:q){
  wz=which(HSQ[,jj]== -1)
  if(length(wz)!=0){
    HSQ = HSQ[-wz,]
    HSQall = HSQall[-wz,]
  }
}

HSQ=data.frame(lapply(HSQ,factor))
HSQnum=HSQall[,33:36]
HSQnum=apply(HSQnum,2,scale)


fullDist=daisy(HSQ,metric="gower")
#HSQ=wg93
kk = 3
fulld=pam(fullDist,k=kk,cluster.only=T)
HSQMCA = tandemMCA_Kmeans(HSQ,c=kk)
ifcbHSQ = iFCB(data=HSQ,nclus=kk,ndim=(kk-1),nstart=100,smartStart=F) 
mcakHSQ = MCAk(data=HSQ,nclus=kk,ndim=(kk-1),nstart=100) 
clusCAHSQ = clusCA(data=HSQ,nclus=kk,ndim=(kk-1),nstart=100) 
grouHSQ = groupals(data=HSQ,nclus=kk,ndim=(kk-1),nstart=100) 

require("fpc")
ProcMatList=list()

orig.dist=daisy(HSQ,metric="gower")


levLab=unlist(lapply(HSQ,levels))
levNum=unlist(lapply(HSQ,function(x) length(levels(x))))
# attLab=rep(names(HSQ),levNum)
nuNamHSQ=rep(c("AF","SE","AG","SD"),times=8)
nuNum=rep(1:8,each=4)
nuNamNum=paste(nuNamHSQ,nuNum,sep="")
attLab=rep(nuNamNum,levNum)

LongLab=paste(attLab,levLab,sep=": ")
shortAttLab=paste("a",1:length(names(HSQ)),sep="_")
levSeq=unlist(lapply(HSQ,function(x) 1:length(levels(x))))
shortLevLab=paste("_l_",levSeq,sep="")
ShortLab=paste(shortAttLab,shortLevLab,sep="")
presPos=seq(from=1, to=length(LongLab),by=1)
source("PaperAppHSQ.R")
myclu=fulld
fulld=c()
fulld$cluID=myclu

PaperAppHSQ(output=clusCAHSQ,K=3,picInPic=F,odata=HSQ,labs=LongLab,splitMap = F,skipMap=F) # figure 4
PaperAppHSQ(output=clusCAHSQ,K=3,picInPic=T,odata=HSQ,labs=LongLab,splitMap = T,skipMap=F) 




  
  
#figures 3 and 5 (left)
PaperAppHSQ(output=fulld,K=kk,picInPic=T,odata=HSQ,labs=LongLab,skipMap=T) # figure 5 (right)


  
SizeMat=rbind(table(fulld$cluID),
              table(HSQMCA$cluID),
              table(mcakHSQ$cluID),
              table(ifcbHSQ$cluID),
              table(grouHSQ$cluID),
              table(clusCAHSQ$cluID))

RelSizeMat=round(SizeMat/nrow(HSQ), digits=2)

rownames(RelSizeMat)=c("fullDim","Tandem","MCAk","iFCB","Groupals","clusCA")

RelSizeMat


###Table 7 in the paper###



prot=protest(clusCAHSQ$attcoord,HSQMCA$attcoord)
rclusCA_vs_MCA=sqrt(1-prot$ss)

prot=protest(clusCAHSQ$attcoord,mcakHSQ$attcoord)
rclusCA_vs_mcak=sqrt(1-prot$ss)

prot=protest(clusCAHSQ$attcoord,grouHSQ$attcoord)
rclusCA_vs_groupals=sqrt(1-prot$ss)

prot=protest(clusCAHSQ$attcoord,ifcbHSQ$attcoord)
rclusCA_vs_ifcb=sqrt(1-prot$ss)

prot=protest(HSQMCA$attcoord,mcakHSQ$attcoord)
rMCA_vs_mcak=sqrt(1-prot$ss)

prot=protest(HSQMCA$attcoord,grouHSQ$attcoord)
rMCA_vs_groupals=sqrt(1-prot$ss)


prot=protest(HSQMCA$attcoord,ifcbHSQ$attcoord)
rMCA_vs_ifcb=sqrt(1-prot$ss)

prot=protest(mcakHSQ$attcoord,grouHSQ$attcoord)
rmcak_vs_groupals=sqrt(1-prot$ss)


prot=protest(mcakHSQ$attcoord,ifcbHSQ$attcoord)
rmcak_vs_ifcb=sqrt(1-prot$ss)

prot=protest(grouHSQ$attcoord,ifcbHSQ$attcoord)
rgroupals_vs_ifcb=sqrt(1-prot$ss)


ProcMat=matrix(0,5,5)
rownames(ProcMat)=c("Tandem","MCAk","iFCB","GROUPALS","clusCA")
colnames(ProcMat)=c("Tandem","MCAk","iFCB","GROUPALS","clusCA")
diag(ProcMat)=1

ProcMat[2,1]=rMCA_vs_mcak
ProcMat[3,1]=rMCA_vs_ifcb
ProcMat[4,1]=rMCA_vs_groupals
ProcMat[5,1]=rclusCA_vs_MCA
ProcMat[1,2]=rMCA_vs_mcak
ProcMat[1,3]=rMCA_vs_ifcb
ProcMat[1,4]=rMCA_vs_groupals
ProcMat[1,5]=rclusCA_vs_MCA

ProcMat[3,2]=rmcak_vs_ifcb
ProcMat[4,2]=rmcak_vs_groupals
ProcMat[5,2]=rclusCA_vs_mcak
ProcMat[2,3]=rmcak_vs_ifcb
ProcMat[2,4]=rmcak_vs_groupals
ProcMat[2,5]=rclusCA_vs_mcak

ProcMat[4,3] = rgroupals_vs_ifcb
ProcMat[5,3] = rclusCA_vs_ifcb
ProcMat[3,4] = rgroupals_vs_ifcb
ProcMat[4,5] = rclusCA_vs_ifcb

ProcMat[4,5] = rclusCA_vs_groupals
ProcMat[5,4] = rclusCA_vs_groupals


ProcMat=round(ProcMat,digits=2)
ProcMat




ARImat=matrix(0,6,6)
rownames(ARImat)=c("fullDim","Tandem","MCAk","iFCB","Groupals","CAclus")
colnames(ARImat)=c("fullDim","Tandem","MCAk","iFCB","Groupals","CAclus")

#fullDim
ARImat[1,1]=cluster.stats(d=orig.dist,clustering=fulld$cluID,alt.clustering=fulld$cluID)$corrected.rand
ARImat[2,1]=cluster.stats(d=orig.dist,clustering=HSQMCA$cluID,alt.clustering=fulld$cluID)$corrected.rand
ARImat[3,1]=cluster.stats(d=orig.dist,clustering=mcakHSQ$cluID,alt.clustering=fulld$cluID)$corrected.rand
ARImat[4,1]=cluster.stats(d=orig.dist,clustering=ifcbHSQ$cluID,alt.clustering=fulld$cluID)$corrected.rand
ARImat[5,1]=cluster.stats(d=orig.dist,clustering=grouHSQ$cluID,alt.clustering=fulld$cluID)$corrected.rand
ARImat[6,1]=cluster.stats(d=orig.dist,clustering=clusCAHSQ$cluID,alt.clustering=fulld$cluID)$corrected.rand


#Tandem
ARImat[1,2]=cluster.stats(d=orig.dist,clustering=fulld$cluID,alt.clustering=HSQMCA$cluID)$corrected.rand
ARImat[2,2]=cluster.stats(d=orig.dist,clustering=HSQMCA$cluID,alt.clustering=HSQMCA$cluID)$corrected.rand
ARImat[3,2]=cluster.stats(d=orig.dist,clustering=mcakHSQ$cluID,alt.clustering=HSQMCA$cluID)$corrected.rand
ARImat[4,2]=cluster.stats(d=orig.dist,clustering=ifcbHSQ$cluID,alt.clustering=HSQMCA$cluID)$corrected.rand
ARImat[5,2]=cluster.stats(d=orig.dist,clustering=grouHSQ$cluID,alt.clustering=HSQMCA$cluID)$corrected.rand
ARImat[6,2]=cluster.stats(d=orig.dist,clustering=clusCAHSQ$cluID,alt.clustering=HSQMCA$cluID)$corrected.rand

#MCAk
ARImat[1,3]=cluster.stats(d=orig.dist,clustering=fulld$cluID,alt.clustering=mcakHSQ$cluID)$corrected.rand
ARImat[2,3]=cluster.stats(d=orig.dist,clustering=HSQMCA$cluID,alt.clustering=mcakHSQ$cluID)$corrected.rand
ARImat[3,3]=cluster.stats(d=orig.dist,clustering=mcakHSQ$cluID,alt.clustering=mcakHSQ$cluID)$corrected.rand
ARImat[4,3]=cluster.stats(d=orig.dist,clustering=ifcbHSQ$cluID,alt.clustering=mcakHSQ$cluID)$corrected.rand
ARImat[5,3]=cluster.stats(d=orig.dist,clustering=grouHSQ$cluID,alt.clustering=mcakHSQ$cluID)$corrected.rand
ARImat[6,3]=cluster.stats(d=orig.dist,clustering=clusCAHSQ$cluID,alt.clustering=mcakHSQ$cluID)$corrected.rand

#ifcb
ARImat[1,4]=cluster.stats(d=orig.dist,clustering=fulld$cluID,alt.clustering=ifcbHSQ$cluID)$corrected.rand
ARImat[2,4]=cluster.stats(d=orig.dist,clustering=HSQMCA$cluID,alt.clustering=ifcbHSQ$cluID)$corrected.rand
ARImat[3,4]=cluster.stats(d=orig.dist,clustering=mcakHSQ$cluID,alt.clustering=ifcbHSQ$cluID)$corrected.rand
ARImat[4,4]=cluster.stats(d=orig.dist,clustering=ifcbHSQ$cluID,alt.clustering=ifcbHSQ$cluID)$corrected.rand
ARImat[5,4]=cluster.stats(d=orig.dist,clustering=grouHSQ$cluID,alt.clustering=ifcbHSQ$cluID)$corrected.rand
ARImat[6,4]=cluster.stats(d=orig.dist,clustering=clusCAHSQ$cluID,alt.clustering=ifcbHSQ$cluID)$corrected.rand

#groupals

ARImat[1,5]=cluster.stats(d=orig.dist,clustering=fulld$cluID,alt.clustering=grouHSQ$cluID)$corrected.rand
ARImat[2,5]=cluster.stats(d=orig.dist,clustering=HSQMCA$cluID,alt.clustering=grouHSQ$cluID)$corrected.rand
ARImat[3,5]=cluster.stats(d=orig.dist,clustering=mcakHSQ$cluID,alt.clustering=grouHSQ$cluID)$corrected.rand
ARImat[4,5]=cluster.stats(d=orig.dist,clustering=ifcbHSQ$cluID,alt.clustering=grouHSQ$cluID)$corrected.rand
ARImat[5,5]=cluster.stats(d=orig.dist,clustering=grouHSQ$cluID,alt.clustering=grouHSQ$cluID)$corrected.rand
ARImat[6,5]=cluster.stats(d=orig.dist,clustering=clusCAHSQ$cluID,alt.clustering=grouHSQ$cluID)$corrected.rand


#CAclus

ARImat[1,6]=cluster.stats(d=orig.dist,clustering=fulld$cluID,alt.clustering=clusCAHSQ$cluID)$corrected.rand
ARImat[2,6]=cluster.stats(d=orig.dist,clustering=HSQMCA$cluID,alt.clustering=clusCAHSQ$cluID)$corrected.rand
ARImat[3,6]=cluster.stats(d=orig.dist,clustering=mcakHSQ$cluID,alt.clustering=clusCAHSQ$cluID)$corrected.rand
ARImat[4,6]=cluster.stats(d=orig.dist,clustering=ifcbHSQ$cluID,alt.clustering=clusCAHSQ$cluID)$corrected.rand
ARImat[5,6]=cluster.stats(d=orig.dist,clustering=grouHSQ$cluID,alt.clustering=clusCAHSQ$cluID)$corrected.rand
ARImat[6,6]=cluster.stats(d=orig.dist,clustering=clusCAHSQ$cluID,alt.clustering=clusCAHSQ$cluID)$corrected.rand

ARImat=round(ARImat,digits=2)
ARImat

